## sail 0.1.0

=== DESCRIPTION ===
Package: sail
Title: Sparse Additive Interaction Learning
Version: 0.1.0
Authors@R: c(
  person("Sahir", "Bhatnagar", email = "sahir.bhatnagar@gmail.com",
  role = c("aut", "cre"), comment = "http://sahirbhatnagar.com/"),
  person("Yi", "Yang", email = "yi.yang6@mcgill.ca",
  role = c("aut"), comment = "http://www.math.mcgill.ca/yyang/"),
  person("Celia", "Greenwood", email = "celia.greenwood@mcgill.ca",
  role = c("aut"), comment = "https://www.mcgill.ca/statisticalgenetics/")
  )
Description: Sparse additive interaction learning with the strong heredity property, i.e., 
    an interaction is selected only if its corresponding main effects are also included. 
    Fits a linear model with non-linear interactions via penalized maximum likelihood. 
    Interactions are limited to a single exposure or environment variable. For more information, 
    see the website below and the accompanying paper: Bhatnagar et al., "A sparse additive model for 
    high-dimensional interactions with an exposure variable", 2019, <DOI:10.1101/445304>.
Depends: R (>= 3.4.0)
Imports: glmnet, gglasso, methods
Suggests: grpreg, truncnorm, foreach, doParallel, testthat, covr,
        vdiffr, knitr, rmarkdown
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
BugReports: https://github.com/sahirbhatnagar/sail/issues
URL: https://sahirbhatnagar.com/sail
RoxygenNote: 6.1.1
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2019-12-05 04:59:48 UTC; sahir
Author: Sahir Bhatnagar [aut, cre] (http://sahirbhatnagar.com/),
  Yi Yang [aut] (http://www.math.mcgill.ca/yyang/),
  Celia Greenwood [aut] (https://www.mcgill.ca/statisticalgenetics/)
Maintainer: Sahir Bhatnagar <sahir.bhatnagar@gmail.com>
Repository: CRAN
Date/Publication: 2019-12-13 15:00:02 UTC

## sail 0.9.0+repack

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(SAIL VERSION 0.9.0
             DESCRIPTION "Squirrel Abstract Image Library"
             LANGUAGES C CXX)

include(GNUInstallDirs)
include(CheckIncludeFiles)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CMakeDependentOption)
include(CMakePushCheckState)
include(CTest)

# Our own cmake scripts
#
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
include(sail_check_alignas)
include(sail_check_builtin_bswap)
include(sail_check_c11_thread_local)
include(sail_check_include)
include(sail_check_init_once_execute_once)
include(sail_codec)
include(sail_enable_asan)
include(sail_enable_pch)
include(sail_enable_posix_source)
include(sail_enable_xopen_source)
include(sail_install_cmake_config)
include(sail_install_pdb)
include(sail_test)

include(JoinPaths)

# https://github.com/jtojnar/cmake-snips#concatenating-paths-when-building-pkg-config-files
#
join_paths(SAIL_LIBDIR_FOR_PKG_CONFIG     "\${exec_prefix}" "${CMAKE_INSTALL_LIBDIR}")
join_paths(SAIL_INCLUDEDIR_FOR_PKG_CONFIG "\${prefix}"      "${CMAKE_INSTALL_INCLUDEDIR}")

# Check features
#
sail_check_alignas()
sail_check_builtin_bswap()
sail_check_c11_thread_local()

# Check for required includes
#
sail_check_include(ctype.h)
sail_check_include(errno.h)
sail_check_include(setjmp.h)
sail_check_include(stdarg.h)
sail_check_include(stdbool.h)
sail_check_include(stddef.h)
sail_check_include(stdint.h)
sail_check_include(stdio.h)
sail_check_include(stdlib.h)
sail_check_include(string.h)
sail_check_include(sys/stat.h)
sail_check_include(sys/types.h)
sail_check_include(wchar.h)

if (UNIX)
    sail_check_include(dirent.h)
    sail_check_include(dlfcn.h)
    sail_check_include(sys/time.h)
    sail_check_include(unistd.h)
endif()

if (WIN32)
    sail_check_include(io.h)
    sail_check_include(share.h)
    sail_check_include(windows.h)
    sail_check_include("windows.h;versionhelpers.h")
endif()

# Options
#
option(SAIL_BUILD_APPS "Build applications." ON)
option(SAIL_BUILD_EXAMPLES "Build examples." ON)
option(SAIL_DEV "Enable developer mode. Be more strict when compiling source code, for example." OFF)
set(SAIL_ENABLE_CODECS "" CACHE STRING "Forcefully enable the codecs specified in this ';'-separated list. \
If an enabled codec fails to find its dependencies, the configuration process fails. \
One can also specify not just individual codecs but codec groups by their priority like that: highest-priority;xbm. \
Other codecs may or may not be enabled depending on found dependencies. \
When SAIL_ENABLE_CODECS is enabled, SAIL_ONLY_CODECS gets ignored.")
set(SAIL_DISABLE_CODECS "" CACHE STRING "Disable the codecs specified in this ';'-separated list. \
One can also specify not just individual codecs but codec groups by their priority like that: highest-priority;xbm.")
option(SAIL_INSTALL_PDB "Install PDB files along with libraries." ON)
set(SAIL_ONLY_CODECS "" CACHE STRING "Forcefully enable only the codecs specified in this ';'-separated list and disable the rest. \
If an enabled codec fails to find its dependencies, the configuration process fails. \
One can also specify not just individual codecs but codec groups by their priority like that: highest-priority;xbm.")
option(BUILD_SHARED_LIBS "Build shared libs. When disabled, sets SAIL_COMBINE_CODECS to ON automatically." ON)
cmake_dependent_option(SAIL_COMBINE_CODECS "Combine all codecs into a single library. When disabled, all codecs are implemented as \
dynamically loaded plugins." OFF "BUILD_SHARED_LIBS" ON)
option(SAIL_THIRD_PARTY_CODECS_PATH "Enable loading third-party codecs from the ';'-separated paths specified in \
the SAIL_THIRD_PARTY_CODECS_PATH environment variable." ON)
option(SAIL_THREAD_SAFE "Enable working in multi-threaded environments by locking the internal context with a mutex." ON)

# When we compile for VCPKG, VCPKG_TARGET_TRIPLET is defined
#
if (VCPKG_TARGET_TRIPLET)
    set(SAIL_VCPKG ON)
else()
    set(SAIL_VCPKG OFF)
endif()

# Number of bytes to read from a file or memory to detect the image
# format by its MIME type.
#
set(SAIL_MAGIC_BUFFER_SIZE 16)

# Our bundled libs
#
if (WIN32 AND NOT SAIL_VCPKG)
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${PROJECT_SOURCE_DIR}/extra/B)

    # For check_c_source_runs() we need to update PATH
    # so checks are able to find bundled libs
    #
    set(EXTRA_LIBS "${PROJECT_SOURCE_DIR}/extra/B/bin")
    string(REPLACE "/" "\\" EXTRA_LIBS "${EXTRA_LIBS}")
    set(ENV{PATH} "$ENV{PATH};${EXTRA_LIBS}")
endif()

# Enable strict C11
#
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)

# Enable strict C++11
#
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Build position-independent targets
#
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Internal flag used to include SAIL headers locally with "header.h" or <sail/header.h> otherwise
#
add_definitions(-DSAIL_BUILD)

if (SAIL_DEV)
    add_definitions(-DSAIL_DEV)
endif()

# Enable as many warnings as possible
#
if (MSVC)
    if (CMAKE_C_FLAGS MATCHES "/W[0-4]")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
        string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    else()
        string(APPEND CMAKE_C_FLAGS " " "/W4")
        string(APPEND CMAKE_CXX_FLAGS " " "/W4")
    endif()
elseif (CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    string(APPEND CMAKE_C_FLAGS " " "-Wall -Wextra")
    string(APPEND CMAKE_CXX_FLAGS " " "-Wall -Wextra")

    if (SAIL_DEV)
        string(APPEND CMAKE_C_FLAGS " " "-pedantic")
        string(APPEND CMAKE_CXX_FLAGS " " "-pedantic")
    endif()
endif()

# Disable undefined symbols
#
if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    string(APPEND CMAKE_SHARED_LINKER_FLAGS " " "-Wl,--no-undefined")
    string(APPEND CMAKE_MODULE_LINKER_FLAGS " " "-Wl,--no-undefined")
elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
    string(APPEND CMAKE_SHARED_LINKER_FLAGS " " "-Wl,-undefined,error")
    string(APPEND CMAKE_MODULE_LINKER_FLAGS " " "-Wl,-undefined,error")
endif()

# Platform definitions used in config.h
#
if (WIN32)
    set(SAIL_WIN32 ON)
endif()

if (UNIX)
    set(SAIL_UNIX ON)
endif()

if (MINGW)
    set(SAIL_MINGW ON)
endif()

if (CYGWIN)
    set(SAIL_CYGWIN ON)
endif()

if (APPLE)
    set(SAIL_APPLE ON)
endif()

# Codecs & icons paths
#
set(SAIL_CODECS_PATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/sail/codecs")
if (WIN32)
    string(REPLACE "/" "\\\\" SAIL_CODECS_PATH "${SAIL_CODECS_PATH}")
endif()

# Global include directory with generated configs
#
include_directories("${PROJECT_BINARY_DIR}/include")

# Configure subdirs
#
add_subdirectory(src/sail-common)
add_subdirectory(src/sail-codecs)
if (SAIL_COMBINE_CODECS)
    add_subdirectory(src/sail-codecs-archive)
endif()
add_subdirectory(src/sail)
add_subdirectory(src/sail-manip)
add_subdirectory(src/bindings/sail-c++)

if (SAIL_BUILD_APPS)
    add_subdirectory(examples/c/sail)
endif()

if (SAIL_BUILD_EXAMPLES)
    find_package(SDL2)
    set(SAIL_SDL_EXAMPLE OFF)

    if (SDL2_FOUND)
        set(SAIL_SDL_EXAMPLE ON)
        add_subdirectory(examples/c/sail-sdl-viewer)
    endif()
endif()

if (BUILD_TESTING)
    add_subdirectory(tests)
endif()

# Error check: This particular build of SAIL cannot load any image
#
if (NOT ENABLED_CODECS AND NOT SAIL_THIRD_PARTY_CODECS_PATH)
    message(FATAL_ERROR "No codecs are enabled and SAIL_THIRD_PARTY_CODECS_PATH is disabled.\nThis particular build of SAIL cannot load any image.")
endif()

# Install our bundled libs if they exist and when VCPKG is not used
#
if (NOT SAIL_VCPKG)
    # When SAIL_COMBINE_CODECS is ON, sail-codecs.dll directly depends on extra libs.
    # Copy them into the bin directory. Otherwise, client applications will fail to run.
    #
    # When SAIL_COMBINE_CODECS is OFF, SAIL loads codecs in runtime. In this case we can put
    # extra libs in a separate directory and update the DLL search path.
    #
    if (SAIL_COMBINE_CODECS)
        set(SAIL_EXTRA_LIBS_INSTALL_PATH "bin")
    else()
        set(SAIL_EXTRA_LIBS_INSTALL_PATH "lib/sail/codecs/lib")
    endif()

    if (WIN32)
        if (EXISTS "${PROJECT_SOURCE_DIR}/extra/B/bin")
            install(DIRECTORY "${PROJECT_SOURCE_DIR}/extra/B/bin/" DESTINATION ${SAIL_EXTRA_LIBS_INSTALL_PATH})
        endif()
        if (EXISTS "${PROJECT_SOURCE_DIR}/extra/B/share/sail/licenses")
            install(DIRECTORY "${PROJECT_SOURCE_DIR}/extra/B/share/sail/licenses/" DESTINATION share/sail/licenses)
        endif()
    else()
        if (EXISTS "${PROJECT_SOURCE_DIR}/extra/B/lib")
            install(DIRECTORY "${PROJECT_SOURCE_DIR}/extra/B/lib/" DESTINATION ${SAIL_EXTRA_LIBS_INSTALL_PATH})
        endif()
    endif()
endif()

if (ENABLED_CODECS)
    string(TOUPPER "${ENABLED_CODECS}" ENABLED_CODECS)

    foreach (codec IN LISTS ENABLED_CODECS)
        set(SAIL_HAVE_CODEC_DEFINES "${SAIL_HAVE_CODEC_DEFINES}#define SAIL_HAVE_BUILTIN_${codec}\n")
    endforeach()

    string(REPLACE ";" " " ENABLED_CODECS "${ENABLED_CODECS}")
endif()

if (DISABLED_CODECS)
    string(TOUPPER "${DISABLED_CODECS}" DISABLED_CODECS)
    string(REPLACE ";" " " DISABLED_CODECS "${DISABLED_CODECS}")
endif()

# Common configuration file
#
configure_file("${PROJECT_SOURCE_DIR}/src/config.h.in" "${PROJECT_BINARY_DIR}/include/sail-common/config.h" @ONLY)
install(FILES "${PROJECT_BINARY_DIR}/include/sail-common/config.h" DESTINATION include/sail/sail-common)

# Print configuration statistics
#
if (SAIL_COLORED_OUTPUT)
    set(SAIL_COLORED_OUTPUT_CLARIFY " (on Windows >= 10 and Unix)")
endif()

message("")
message("***************************************")
message("*")
message("* Configuration statistics: ")
message("*")
message("* CMake version:                ${CMAKE_VERSION}")
message("* CMake C flags:                ${CMAKE_C_FLAGS}")
message("* CMake CXX flags:              ${CMAKE_CXX_FLAGS}")
message("* CMake shared link flags:      ${CMAKE_SHARED_LINKER_FLAGS}")
message("* CMake static link flags:      ${CMAKE_STATIC_LINKER_FLAGS}")
message("* CMake module link flags:      ${CMAKE_MODULE_LINKER_FLAGS}")
message("*")
message("* SAIL version:                 ${PROJECT_VERSION}")
message("* Developer mode:               ${SAIL_DEV}")
message("* VCPKG mode:                   ${SAIL_VCPKG}")
message("* Shared build:                 ${BUILD_SHARED_LIBS}")
message("*   Combine codecs [*]:         ${SAIL_COMBINE_CODECS}")
message("* Thread-safe:                  ${SAIL_THREAD_SAFE}")
message("* SAIL_THIRD_PARTY_CODECS_PATH: ${SAIL_THIRD_PARTY_CODECS_PATH}")
message("* Colored output:               ${SAIL_COLORED_OUTPUT}${SAIL_COLORED_OUTPUT_CLARIFY}")
message("* Build apps:                   ${SAIL_BUILD_APPS}")
message("* Build examples:               ${SAIL_BUILD_EXAMPLES}")
message("* Build SDL example:            ${SAIL_SDL_EXAMPLE}")
message("* Build tests:                  ${BUILD_TESTING}")
message("* Install PDB files:            ${SAIL_INSTALL_PDB}")
message("*")
message("* SAIL_HAVE_BUILTIN_BSWAP16:    ${SAIL_HAVE_BUILTIN_BSWAP16_DISPLAY}")
message("* SAIL_HAVE_BUILTIN_BSWAP32:    ${SAIL_HAVE_BUILTIN_BSWAP32_DISPLAY}")
message("* SAIL_HAVE_BUILTIN_BSWAP64:    ${SAIL_HAVE_BUILTIN_BSWAP64_DISPLAY}")
message("*")
message("* [*] - these options depend on other options, their values may be altered by CMake.")
message("*       For example, if you configure with -DBUILD_SHARED_LIBS=OFF -DSAIL_COMBINE_CODECS=OFF,")
message("*       the final value of SAIL_COMBINE_CODECS will be ON.")
message("*")
message("* Install prefix:               ${CMAKE_INSTALL_PREFIX}")
message("* LIBDIR:                       ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
message("* INCLUDEDIR:                   ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
message("* DATADIR:                      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}")
message("*")

=== tests/CMakeLists.txt ===
# Test images
#
set(SAIL_TEST_IMAGES_PATH ${CMAKE_CURRENT_SOURCE_DIR}/images)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/images/test-images.h.in ${PROJECT_BINARY_DIR}/include/test-images.h @ONLY)

# Dependencies
#
add_subdirectory(munit)
add_subdirectory(sail-comparators)
add_subdirectory(sail-dump)

# Actual tests
#
add_subdirectory(sail-common)
add_subdirectory(sail)
add_subdirectory(sail-manip)
add_subdirectory(bindings/c++)

=== src/sail-codecs/CMakeLists.txt ===
# Common dependencies that can be re-used by different codecs
#
add_subdirectory(common/bmp)

# List of codecs
#
set(HIGHEST_PRIORITY_CODECS gif jpeg png tiff)
set(HIGH_PRIORITY_CODECS    bmp svg)
set(MEDIUM_PRIORITY_CODECS  avif jpeg2000 jpegxl webp)
set(LOW_PRIORITY_CODECS     ico pcx psd qoi tga)
set(LOWEST_PRIORITY_CODECS  wal xbm)

set(CODECS ${HIGHEST_PRIORITY_CODECS}
           ${HIGH_PRIORITY_CODECS}
           ${MEDIUM_PRIORITY_CODECS}
           ${LOW_PRIORITY_CODECS}
           ${LOWEST_PRIORITY_CODECS})
list(SORT CODECS)

# Expand codecs priorities to actual codecs.
#
macro(sail_expand_priorities)
    set(TEMP_LIST)

    foreach (codec IN LISTS ${ARGV0})
        if (codec STREQUAL "highest-priority")
            list(APPEND TEMP_LIST ${HIGHEST_PRIORITY_CODECS})
        elseif (codec STREQUAL "high-priority")
            list(APPEND TEMP_LIST ${HIGH_PRIORITY_CODECS})
        elseif (codec STREQUAL "medium-priority")
            list(APPEND TEMP_LIST ${MEDIUM_PRIORITY_CODECS})
        elseif (codec STREQUAL "low-priority")
            list(APPEND TEMP_LIST ${LOW_PRIORITY_CODECS})
        elseif (codec STREQUAL "lowest-priority")
            list(APPEND TEMP_LIST ${LOWEST_PRIORITY_CODECS})
        else()
            list(APPEND TEMP_LIST ${codec})
        endif()
    endforeach()

    set(${ARGV0} ${TEMP_LIST})
endmacro()

# Check if the input codecs list matches the existing codecs list
# and fail with an error if any of the input codecs doesn't exist.
#
# For example: sail_check_codec_presence(jpeg;png jpeg;png;tiff) succeeds
#              sail_check_codec_presence(jpeg;png ico;jpeg;tiff) fails
#
function(sail_check_codec_presence VAR_INPUT_LIST CHECK_AGAINST_LIST)
    foreach (codec IN LISTS ${VAR_INPUT_LIST})
        if (NOT ${codec} IN_LIST CHECK_AGAINST_LIST)
            message(FATAL_ERROR "Codec '${codec}' doesn't exist in the list of the valid codecs '${CHECK_AGAINST_LIST}'")
        endif()
    endforeach()
endfunction()

sail_expand_priorities(SAIL_ONLY_CODECS)
sail_expand_priorities(SAIL_ENABLE_CODECS)
sail_expand_priorities(SAIL_DISABLE_CODECS)

list(REMOVE_DUPLICATES SAIL_ONLY_CODECS)
list(REMOVE_DUPLICATES SAIL_ENABLE_CODECS)
list(REMOVE_DUPLICATES SAIL_DISABLE_CODECS)

sail_check_codec_presence(SAIL_ONLY_CODECS "${CODECS}")
sail_check_codec_presence(SAIL_ENABLE_CODECS "${CODECS}")
sail_check_codec_presence(SAIL_DISABLE_CODECS "${CODECS}")

# Filter out codecs
#
if (SAIL_ONLY_CODECS)
    set(ENABLED_CODECS "")

    foreach (codec IN LISTS CODECS)
        if (${codec} IN_LIST SAIL_ONLY_CODECS)
            list(APPEND ENABLED_CODECS ${codec})
            list(APPEND FORCED_CODECS ${codec})
        else()
            list(APPEND DISABLED_CODECS ${codec})
        endif()
    endforeach()
else()
    set(ENABLED_CODECS ${CODECS})

    if (SAIL_ENABLE_CODECS)
        foreach (codec IN LISTS SAIL_ENABLE_CODECS)
            list(APPEND FORCED_CODECS ${codec})
        endforeach()
    endif()
endif()

if (SAIL_DISABLE_CODECS)
    foreach (codec IN LISTS ENABLED_CODECS)
        if (${codec} IN_LIST SAIL_DISABLE_CODECS)
            list(REMOVE_ITEM ENABLED_CODECS ${codec})
            list(REMOVE_ITEM FORCED_CODECS ${codec})
            list(APPEND DISABLED_CODECS ${codec})
        endif()
    endforeach()
endif()

foreach (codec IN LISTS FORCED_CODECS)
    string(TOUPPER ${codec} codec_upper)
    set(SAIL_CODEC_${codec_upper}_REQUIRED_OPTION "REQUIRED")
endforeach()

# Add enabled codecs.
#
foreach (codec ${ENABLED_CODECS})
    add_subdirectory(${codec})

    # Codecs can disable themselves due to missing dependencies.
    #
    if (NOT TARGET sail-codec-${codec})
        list(REMOVE_ITEM ENABLED_CODECS ${codec})
        list(APPEND DISABLED_CODECS ${codec})
    endif()
endforeach()

# Export extra dependencies like giflib for static builds to the parent scope
#
if (NOT BUILD_SHARED_LIBS)
    foreach (dependency IN LISTS SAIL_CODECS_FIND_DEPENDENCIES)
        string(REPLACE "," ";" dependency ${dependency})
        list(GET dependency 0 dependency_search_mechanism)

        if (dependency_search_mechanism STREQUAL "find_dependency")
            list(GET dependency 1 dependency_name)
            list(GET dependency 2 dependency_link_target)

            set(SAIL_CODECS_FIND_DEPENDENCIES_EXPANDED "${SAIL_CODECS_FIND_DEPENDENCIES_EXPANDED}
# ${dependency_name}
find_dependency(${dependency_name} REQUIRED)
set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES ${dependency_link_target})
")
        elseif(dependency_search_mechanism STREQUAL "find_library")
            list(GET dependency 1 dependency_release_names)
            list(GET dependency 2 dependency_debug_names)

            # Get "webp" from "webp libwebp"
            set(dependency_release_names_as_list ${dependency_release_names})
            string(REGEX REPLACE " +" ";" dependency_release_names_as_list ${dependency_release_names_as_list})
            list(GET dependency_release_names_as_list 0 dependency_name)

            set(SAIL_CODECS_FIND_DEPENDENCIES_EXPANDED "${SAIL_CODECS_FIND_DEPENDENCIES_EXPANDED}
# ${dependency_name}
find_library(${dependency_name}_RELEASE_LIBRARY NAMES ${dependency_release_names})
find_library(${dependency_name}_DEBUG_LIBRARY NAMES ${dependency_debug_names} ${dependency_release_names})

if (NOT ${dependency_name}_RELEASE_LIBRARY OR NOT ${dependency_name}_DEBUG_LIBRARY)
    message(FATAL_ERROR \"Missing dependency: ${dependency_name}\")
endif()

set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES \$<\$<CONFIG:Release>:\${${dependency_name}_RELEASE_LIBRARY}> \$<\$<CONFIG:Debug>:\${${dependency_name}_DEBUG_LIBRARY}>)
")
        else()
            message(FATAL_ERROR "Unsupported dependencies search mechanism '${dependency_search_mechanism}'")
        endif()
    endforeach()

    set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES_EXPANDED} PARENT_SCOPE)
endif()

# Export the list of codecs to the parent CMake file to print statistics
#
set(ENABLED_CODECS ${ENABLED_CODECS} PARENT_SCOPE)
set(DISABLED_CODECS ${DISABLED_CODECS} PARENT_SCOPE)

=== src/sail-manip/CMakeLists.txt ===
add_library(sail-manip
                cmyk.c
                cmyk.h
                conversion_options.c
                conversion_options.h
                convert.c
                convert.h
                manip_common.h
                manip_utils.c
                manip_utils.h
                sail-manip.h
                ycbcr.c
                ycbcr.h
                ycck.c
                ycck.h)

# Build a list of public headers to install
#
set(PUBLIC_HEADERS conversion_options.h
                   convert.h
                   manip_common.h
                   sail-manip.h)

set_target_properties(sail-manip PROPERTIES
                                 VERSION ${PROJECT_VERSION}
                                 SOVERSION ${PROJECT_VERSION_MAJOR}
                                 PUBLIC_HEADER "${PUBLIC_HEADERS}")

sail_enable_asan(TARGET sail-manip)

sail_enable_pch(TARGET sail-manip HEADER sail-manip.h)

if (SAIL_INSTALL_PDB)
    sail_install_pdb(TARGET sail-manip)
endif()

# Definitions, includes, link
#
target_include_directories(sail-manip PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>)

target_link_libraries(sail-manip PUBLIC sail-common)

# pkg-config integration
#
get_target_property(VERSION sail-manip VERSION)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/sail-manip.pc.in"
                "${CMAKE_CURRENT_BINARY_DIR}/sail-manip.pc" @ONLY)

# Installation
#
install(TARGETS sail-manip
        EXPORT SailManipTargets
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sail/sail-manip")

# Install development packages
#
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sail-manip.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

sail_install_cmake_config(TARGET "SailManip" FOLDER "sailmanip" VERSION "${VERSION}")

=== src/sail/CMakeLists.txt ===
if (SAIL_THREAD_SAFE)
    set(THREADING_SOURCES threading.h threading.c)
endif()

add_library(sail
                codec.c
                codec_bundle.h
                codec_bundle_node.c
                codec_bundle_node.h
                codec_bundle_node_private.c
                codec_bundle_node_private.h
                codec_bundle_private.c
                codec_bundle_private.h
                codec_info.c
                codec_info.h
                codec_info_private.c
                codec_info_private.h
                codec_layout.h
                codec_priority.h
                context.c
                context.h
                context_private.c
                context_private.h
                ini.c
                ini.h
                io_file.c
                io_file.h
                io_memory.c
                io_memory.h
                io_noop.c
                io_noop.h
                sail.h
                sail_advanced.c
                sail_advanced.h
                sail_deep_diver.c
                sail_deep_diver.h
                sail_junior.c
                sail_junior.h
                sail_private.c
                sail_private.h
                sail_technical_diver.c
                sail_technical_diver.h
                sail_technical_diver_private.c
                sail_technical_diver_private.h
                ${THREADING_SOURCES})

# Build a list of public headers to install
#
set(PUBLIC_HEADERS codec_bundle.h
                   codec_bundle_node.h
                   codec_info.h
                   codec_priority.h
                   context.h
                   io_file.h
                   io_memory.h
                   io_noop.h
                   sail.h
                   sail_advanced.h
                   sail_deep_diver.h
                   sail_junior.h
                   sail_technical_diver.h)

set_target_properties(sail PROPERTIES
                           VERSION ${PROJECT_VERSION}
                           SOVERSION ${PROJECT_VERSION_MAJOR}
                           PUBLIC_HEADER "${PUBLIC_HEADERS}")

sail_enable_asan(TARGET sail)

# setenv
sail_enable_posix_source(TARGET sail VERSION 200112L)

sail_enable_pch(TARGET sail HEADER sail.h)

if (SAIL_INSTALL_PDB)
    sail_install_pdb(TARGET sail)
endif()

# Definitions, includes, link
#
target_include_directories(sail PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>)
# Simplify the INIH parser
target_compile_definitions(sail PRIVATE INI_ALLOW_MULTILINE=0 INI_ALLOW_INLINE_COMMENTS=0 INI_CUSTOM_ALLOCATOR=0 INI_STOP_ON_FIRST_ERROR=1 INI_MAX_LINE=500 INI_API=SAIL_HIDDEN)

if (SAIL_COMBINE_CODECS)
    # Transfer user requirements
    #
    target_link_libraries(sail PRIVATE sail-codecs)
endif()

target_link_libraries(sail PUBLIC sail-common)

if (SAIL_THREAD_SAFE)
    if (WIN32)
        sail_check_init_once_execute_once()
    elseif (UNIX)
        # pthread_once()
        find_package(Threads REQUIRED)
        target_link_libraries(sail PUBLIC ${CMAKE_THREAD_LIBS_INIT})

        # pthread_mutexattr_settype()
        sail_enable_xopen_source(TARGET sail VERSION 500)

        target_link_libraries(sail PRIVATE dl)
    endif()
endif()

# pkg-config integration
#
get_target_property(VERSION sail VERSION)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pkgconfig/sail.pc.in"
                "${CMAKE_CURRENT_BINARY_DIR}/sail.pc" @ONLY)

# Installation
#
install(TARGETS sail
        EXPORT SailTargets
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sail/sail")

# Install layouts for debugging codecs
#
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/layout/" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/sail/sail/layout")

# Install development packages
#
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sail.pc"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

if (SAIL_COMBINE_CODECS)
    set(SAIL_CODECS_FIND_DEPENDENCY "find_dependency(SailCodecs REQUIRED PATHS \${CMAKE_CURRENT_LIST_DIR})")
endif()

sail_install_cmake_config(TARGET "Sail" FOLDER "sail" VERSION "${VERSION}")

=== tests/sail-manip/CMakeLists.txt ===
sail_test(TARGET closest-conversion SOURCES closest-conversion.c LINK sail sail-manip)

=== tests/sail/CMakeLists.txt ===
sail_test(TARGET io-produce-same-images SOURCES io-produce-same-images.c LINK sail sail-comparators)

=== src/sail-codecs/jpeg/CMakeLists.txt ===
find_package(JPEG ${SAIL_CODEC_JPEG_REQUIRED_OPTION})

if (NOT JPEG_FOUND)
    return()
endif()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_dependency(JPEG REQUIRED)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES JPEG::JPEG)
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_dependency,JPEG,JPEG::JPEG" PARENT_SCOPE)

# Check for JPEG ICC functions that were added in libjpeg-turbo-1.5.90
#
cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})

    check_c_source_compiles(
        "
        #include <stdio.h>
        #include <jpeglib.h>

        int main(int argc, char *argv[]) {
            jpeg_read_icc_profile(NULL, NULL, NULL);
            jpeg_write_icc_profile(NULL, NULL, 0);
            return 0;
        }
    "
    HAVE_JPEG_ICCP
    )
cmake_pop_check_state()

# Used in .codec.info
#
if (HAVE_JPEG_ICCP)
    set(JPEG_CODEC_INFO_FEATURE_ICCP ";ICCP")
endif()

# Check for libjpeg-turbo
#
cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES ${JPEG_LIBRARIES})

    check_c_source_compiles(
        "
        #include <stdio.h>
        #include <jpeglib.h>

        int main(int argc, char *argv[]) {
            J_COLOR_SPACE ext = JCS_EXT_RGB;
            return 0;
        }
    "
    HAVE_JPEG_JCS_EXT
    )
cmake_pop_check_state()

# Used in .codec.info
#
if (HAVE_JPEG_JCS_EXT)
    set(JPEG_CODEC_INFO_WRITE_EXT "BPP24-RGB;")
endif()

# Common codec configuration
#
sail_codec(NAME jpeg
            SOURCES helpers.h helpers.c io_dest.h io_dest.c io_src.h io_src.c jpeg.c
            ICON jpeg.png
            DEPENDENCY_INCLUDE_DIRS ${JPEG_INCLUDE_DIR}
            DEPENDENCY_LIBS ${JPEG_LIBRARIES})

# Add compile options to the target based on our findings
#
if (HAVE_JPEG_ICCP)
    target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_HAVE_JPEG_ICCP)
endif()

if (HAVE_JPEG_JCS_EXT)
    target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_HAVE_JPEG_JCS_EXT)
endif()

=== src/sail-codecs/jpeg2000/CMakeLists.txt ===
find_package(Jasper ${SAIL_CODEC_JPEG2000_REQUIRED_OPTION})

if (NOT JASPER_FOUND)
    return()
endif()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_package(Jasper)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES ${JASPER_LIBRARIES})
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_dependency,Jasper,\${JASPER_LIBRARIES}" PARENT_SCOPE)

# Common codec configuration
#
sail_codec(NAME jpeg2000
            SOURCES helpers.h helpers.c jpeg2000.c
            ICON jpeg2000.png
            DEPENDENCY_INCLUDE_DIRS ${JASPER_INCLUDE_DIR}
            DEPENDENCY_LIBS ${JASPER_LIBRARIES})

=== src/sail-codecs/jpegxl/CMakeLists.txt ===
find_library(JPEGXL_LIBRARY jxl                 NAMES jxl jxl-static                 ${SAIL_CODEC_JPEGXL_REQUIRED_OPTION})
find_library(JPEGXL_THREADS_LIBRARY jxl_threads NAMES jxl_threads jxl_threads-static ${SAIL_CODEC_JPEGXL_REQUIRED_OPTION})
find_path(JPEGXL_INCLUDE_DIRS jxl/decode.h                                           ${SAIL_CODEC_JPEGXL_REQUIRED_OPTION})

if (NOT JPEGXL_LIBRARY OR NOT JPEGXL_THREADS_LIBRARY OR NOT JPEGXL_INCLUDE_DIRS)
    return()
endif()

# Find dependencies for static builds as libjxl doesn't provide CMake configs
# to find them automatically.
#
find_library(HWY_LIBRARY           NAMES hwy                              ${SAIL_CODEC_JPEGXL_REQUIRED_OPTION})
find_library(BROTLI_COMMON_LIBRARY NAMES brotlicommon brotlicommon-static ${SAIL_CODEC_JPEGXL_REQUIRED_OPTION})
find_library(BROTLI_DEC_LIBRARY    NAMES brotlidec brotlidec-static       ${SAIL_CODEC_JPEGXL_REQUIRED_OPTION})

if (NOT HWY_LIBRARY OR NOT BROTLI_COMMON_LIBRARY OR NOT BROTLI_DEC_LIBRARY)
    return()
endif()

# For static builds libjxl requires -DJXL_STATIC_DEFINE
#
if (JPEGXL_LIBRARY MATCHES "jxl-static")
    set(JXL_STATIC_DEFINE "JXL_STATIC_DEFINE")
endif()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_library(jxl_RELEASE_LIBRARY NAMES jxl jxl-static)
# find_library(jxl_DEBUG_LIBRARY NAMES jxl jxl-static)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES $<$<CONFIG:Release>:${jxl_RELEASE_LIBRARY}> $<$<CONFIG:Debug>:${jxl_DEBUG_LIBRARY}>)
#
# etc.
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,jxl jxl-static,jxl jxl-static")
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,jxl_threads jxl_threads-static,jxl_threads jxl_threads-static")

set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,hwy,hwy")
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,brotlicommon brotlicommon-static,brotlicommon brotlicommon-static")
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,brotlidec brotlidec-static,brotlidec brotlidec-static")

set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} PARENT_SCOPE)

# Common codec configuration
#
sail_codec(NAME jpegxl
            SOURCES helpers.h helpers.c jpegxl.c memory.h memory.c
            ICON jpegxl.png
            DEPENDENCY_COMPILE_DEFINITIONS ${JXL_STATIC_DEFINE}
            DEPENDENCY_INCLUDE_DIRS ${JPEGXL_INCLUDE_DIRS}
            DEPENDENCY_LIBS ${BROTLI_COMMON_LIBRARY} ${BROTLI_DEC_LIBRARY} ${HWY_LIBRARY}
                            ${JPEGXL_LIBRARY} ${JPEGXL_THREADS_LIBRARY})

=== src/sail-codecs/svg/CMakeLists.txt ===
find_library(SVG_LIBRARY resvg     ${SAIL_CODEC_SVG_REQUIRED_OPTION})
find_path(SVG_INCLUDE_DIRS resvg.h ${SAIL_CODEC_SVG_REQUIRED_OPTION})

if (NOT SVG_LIBRARY OR NOT SVG_INCLUDE_DIRS)
    return()
endif()

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_INCLUDES ${SVG_INCLUDE_DIRS})

    check_c_source_compiles(
        "
        #include <resvg.h>

        int main(int argc, char *argv[]) {
            resvg_fit_to resvg_fit_to = { RESVG_FIT_TO_ORIGINAL, 0 };
            return 0;
        }
    "
    HAVE_RESVG_FIT_TO
    )
cmake_pop_check_state()

# This will add the following CMake rules to the CMake config for static builds so a client
# application links against the required dependencies:
#
# find_library(resvg_RELEASE_LIBRARY NAMES resvg)
# find_library(resvg_DEBUG_LIBRARY NAMES resvg)
# set_property(TARGET SAIL::sail-codecs APPEND PROPERTY INTERFACE_LINK_LIBRARIES $<$<CONFIG:Release>:${resvg_RELEASE_LIBRARY}> $<$<CONFIG:Debug>:${resvg_DEBUG_LIBRARY}>)
#
set(SAIL_CODECS_FIND_DEPENDENCIES ${SAIL_CODECS_FIND_DEPENDENCIES} "find_library,resvg,resvg" PARENT_SCOPE)

# Common codec configuration
#
sail_codec(NAME svg
            SOURCES svg.c
            ICON svg.png
            DEPENDENCY_INCLUDE_DIRS ${SVG_INCLUDE_DIRS}
            DEPENDENCY_LIBS ${SVG_LIBRARY})

if (HAVE_RESVG_FIT_TO)
    target_compile_definitions(${SAIL_CODEC_TARGET} PRIVATE SAIL_HAVE_RESVG_FIT_TO)
endif()

=== src/sail-codecs/tga/CMakeLists.txt ===
# Common codec configuration
#
sail_codec(NAME tga SOURCES helpers.h helpers.c tga.c ICON tga.png)

=== debian/changelog ===
sail (0.9.0+repack-2) unstable; urgency=medium

  * Add dependency on sail-codecs. (Closes: #1059743)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 31 Dec 2023 22:45:06 +0000

sail (0.9.0+repack-1) unstable; urgency=medium

  * Initial release. (Closes: #1053729)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 15 Dec 2023 23:06:31 +0000

=== debian/control ===
Source: sail
Section: libs
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13), libgif-dev, libjpeg-dev, cmake,
 libpng-dev, libtiff-dev, libavif-dev, libwebp-dev, libjxl-dev
Standards-Version: 4.6.2
Homepage: https://github.com/HappySeaFox/sail
Vcs-Browser: https://salsa.debian.org/sudip/sail
Vcs-Git: https://salsa.debian.org/sudip/sail.git

Package: libsail-common0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL common client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package contains the shared library.

Package: libsail-common-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-common0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL common client library (development files)
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package is needed to compile programs against libsail-common0.

Package: libsail-manip0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL image manipulation library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides image manipulation functions.
 .
 This package contains the shared library.

Package: libsail-manip-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-manip0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL image manipulation library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package is needed to compile programs against libsail-manip0.

Package: libsail0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, sail-codecs (= ${binary:Version})
Description: SAIL client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL client libraries.
 .
 This package contains the shared library.

Package: libsail-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL client library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL development headers and libraries.

Package: libsail-c++0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL C++ client library (shared library)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL client libraries.

Package: libsail-c++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsail-c++0 (= ${binary:Version}), ${misc:Depends}
Description: SAIL C++ client library (development files)
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides high-level SAIL C++ development headers and libraries.

Package: sail-codecs
Architecture: any
Multi-Arch: same
Section: misc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: SAIL common image codecs
 SAIL is a fast and lightweight cross-platform image decoding
 and encoding library providing multi-leveled APIs from one-liners
 to complex use-cases with custom I/O sources.
 .
 This package provides low-level SAIL image codecs.
